module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 9);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("flexschema");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _flexstore = __webpack_require__(3);

var _flexstore2 = _interopRequireDefault(_flexstore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let FieldStore = class FieldStore extends Store {

	has(_ref) {
		let namespace = _ref.namespace,
		    name = _ref.name;

		return super.has({ path: [namespace, name] });
	}

	set(_ref2) {
		let namespace = _ref2.namespace,
		    name = _ref2.name,
		    component = _ref2.component;

		super.set({
			path: [namespace, name],
			value: {
				component
			}
		});
	}

	get(_ref3) {
		let namespace = _ref3.namespace,
		    name = _ref3.name;

		return super.get({ path: [namespace, name] });
	}

	remove(_ref4) {
		let namespace = _ref4.namespace,
		    name = _ref4.name;

		if (this.has({ namespace, name })) {
			super.remove({ path: [namespace, name] });
		}
	}
};
exports.default = FieldStore;

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("flexstore");

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _class, _temp2;

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _objectPathImmutable = __webpack_require__(12);

var _flexschema = __webpack_require__(0);

var _FieldStore = __webpack_require__(2);

var _FieldStore2 = _interopRequireDefault(_FieldStore);

var _ProcessorStore = __webpack_require__(8);

var _ProcessorStore2 = _interopRequireDefault(_ProcessorStore);

var _Architect = __webpack_require__(7);

var _Architect2 = _interopRequireDefault(_Architect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const store = new _FieldStore2.default(),
      processorStore = new _ProcessorStore2.default();

_Architect2.default.store = store;
_Architect2.default.processorStore = processorStore;

let FlexForm = (_temp2 = _class = class FlexForm extends _react.Component {
	constructor() {
		var _temp;

		return _temp = super(...arguments), this.save = (_ref) => {
			let path = _ref.path,
			    value = _ref.value;
			return this.props.onChange({
				value: path.setData({
					data: this.props.value,
					newData: value,
					immutable: true
				})
			});
		}, this.onSubmit = e => {
			if (this.props.onSubmit) {
				this.props.onSubmit({ e, value: this.props.value });
			} else {
				e.preventDefault();
			}
		}, _temp;
	}

	getChildContext() {
		return {
			flexForm: {
				data: this.props.value,
				meta: this.props.meta,
				schema: this.props.schema,
				save: this.save,
				schemaPath: new _flexschema.Path(),
				path: new _flexschema.Path()
			}
		};
	}

	getChildren() {
		if (this.props.plan) {
			const architect = new _Architect2.default({
				namespace: this.props.namespace,
				schema: this.props.schema,
				plan: this.props.plan,
				data: this.props.value
			});
			architect.build();
			return architect.tree;
		}

		return this.props.children;
	}

	render() {
		return _jsx('form', {
			className: this.props.className,
			style: this.props.style,
			onSubmit: this.onSubmit
		}, void 0, this.getChildren());
	}

	static registerField(args) {
		this.store.set(args);
	}

	static registerProcessor(args) {
		this.processorStore.set(args);
	}
}, _class.defaultProps = {
	onChange: () => {},
	className: '',
	style: {}
}, _class.childContextTypes = {
	flexForm: _react.PropTypes.shape({
		data: _react.PropTypes.any.isRequired,
		meta: _react.PropTypes.object.isRequired,
		schema: _react.PropTypes.object.isRequired,
		save: _react.PropTypes.func.isRequired,
		path: _react.PropTypes.object.isRequired
	}).isRequired
}, _class.store = store, _class.processorStore = processorStore, _temp2);
exports.default = FlexForm;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extendableError = __webpack_require__(10);

var _extendableError2 = _interopRequireDefault(_extendableError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let FlexFormError = class FlexFormError extends _extendableError2.default {

	constructor(message) {
		super(`FlexFormError: ${message}`);
	}
};
exports.default = FlexFormError;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _isEqual = __webpack_require__(11);

var _isEqual2 = _interopRequireDefault(_isEqual);

var _flexschema = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
	let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	return Original => {
		var _class, _temp;

		return _temp = _class = class FlexField extends _react.Component {

			constructor(props, context) {
				super(props, context);

				this.save = (_ref) => {
					let value = _ref.value;
					return this.context.flexForm.save({
						path: this.state.path,
						value
					});
				};

				this.state = this.getState({ props, context });
			}

			componentWillReceiveProps(nextProps, nextContext) {
				if (!(0, _isEqual2.default)(this.props, nextProps) || !(0, _isEqual2.default)(this.context, nextContext)) {
					this.setState(this.getState({ props: nextProps, context: nextContext }));
				}
			}

			getState(_ref2) {
				let props = _ref2.props,
				    context = _ref2.context;

				const path = this.getPath({ pathPiece: props.path, pathObject: context.flexForm.path }),
				      schema = this.getSchema({
					path,
					parentSchema: context.flexForm.schema
				}),
				      data = this.getData({
					path,
					context
				});

				return {
					path,
					schema,
					data
				};
			}

			getPath(_ref3) {
				let pathPiece = _ref3.pathPiece,
				    pathObject = _ref3.pathObject;

				return pathPiece ? pathObject.push(pathPiece) : pathObject;
			}

			getSchema(_ref4) {
				let path = _ref4.path,
				    parentSchema = _ref4.parentSchema;

				return parentSchema.extract({ path });
			}

			getData(_ref5) {
				let path = _ref5.path,
				    context = _ref5.context;

				return path.getData({ data: context.flexForm.data });
			}

			getChildContext() {
				return {
					flexForm: _extends({}, this.context.flexForm, {
						path: this.state.path
					})
				};
			}

			getChildren() {
				const schema = this.state.schema,
				      type = schema.getField({ name: 'type' }),
				      hasSharedValues = !!schema.getField({ name: 'values' });

				if ((type === 'array' || type === 'object') && hasSharedValues && _react.Children.count(this.props.children) === 1) {
					if (type === 'array') {
						return this.state.data.map((itemData, index) => (0, _react.cloneElement)(this.props.children, {
							path: index
						}));
					}

					return Object.keys(this.state.data).map(key => (0, _react.cloneElement)(this.props.children, {
						path: key
					}));
				}

				return this.props.children;
			}

			render() {
				let componentProps = _extends({}, this.props, {
					flexForm: this.state,
					children: this.getChildren(),
					onChange: this.save,
					value: this.state.data
				});

				if (options.generateProps) {
					componentProps = _extends({}, componentProps, options.generateProps({ flexFormContext: this, componentProps }));
				}

				return _react2.default.createElement(Original, componentProps);
			}
		}, _class.contextTypes = {
			flexForm: _react.PropTypes.shape({
				data: _react.PropTypes.any.isRequired,
				meta: _react.PropTypes.object.isRequired,
				schema: _react.PropTypes.object.isRequired,
				save: _react.PropTypes.func.isRequired,
				path: _react.PropTypes.object.isRequired
			}).isRequired
		}, _class.childContextTypes = {
			flexForm: _react.PropTypes.shape({
				data: _react.PropTypes.any.isRequired,
				meta: _react.PropTypes.object.isRequired,
				schema: _react.PropTypes.object.isRequired,
				save: _react.PropTypes.func.isRequired,
				path: _react.PropTypes.object.isRequired
			}).isRequired
		}, _temp;
	};
};

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _flexschema = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Architect = class Architect {
	// value set in the FlexForm.js file
	constructor(_ref) {
		let namespace = _ref.namespace,
		    schema = _ref.schema,
		    plan = _ref.plan,
		    data = _ref.data;
		this.tree = null;

		this.namespace = namespace;
		this.schema = schema;
		this.plan = plan;
		this.data = data;
	} // value set in the FlexForm.js file

	build() {
		this.tree = this._getComponent({
			isRoot: true,
			plan: this.plan,
			parentPath: new _flexschema.Path(),
			parentSchema: this.schema
		});
	}

	_getComponent(_ref2) {
		let plan = _ref2.plan,
		    parentPath = _ref2.parentPath,
		    parentSchema = _ref2.parentSchema,
		    key = _ref2.key;
		var _ref2$isRoot = _ref2.isRoot;
		let isRoot = _ref2$isRoot === undefined ? false : _ref2$isRoot;

		let args = {
			plan,
			parentPath,
			parentSchema,
			key,
			isRoot,
			name: null,
			path: null,
			props: null,
			children: null,
			schema: null,
			renderedChildren: null,
			fieldComponent: null,
			isProcessed: {
				name: false,
				fieldComponent: false,
				props: false,
				children: false,
				path: false,
				schema: false,
				renderedChildren: false,
				key: false
			},
			settings: _extends({
				renderWhenEmpty: false,
				renderWhenNoData: false
			}, plan.settings ? plan.settings : {}),
			architect: this
		};

		this._processDynamic(args);

		args.name = this._getName(args);
		if (!args) {
			return null;
		}
		args.isProcessed.name = true;

		const FieldComponent = this._getFieldComponent(args);
		args.fieldComponent = FieldComponent;
		args.isProcessed.fieldComponent = true;

		if (args.plan.props) {
			args.props = this._getProps(args);
		} else {
			args.props = {};
		}

		args.isProcessed.props = true;

		if (args.plan.children) {
			args.children = this._getChildren(args);
		}

		args.isProcessed.children = true;

		if (args.props.path) {
			args.path = this._getPath(args);
			args.isProcessed.path = true;

			args.schema = this._getSchema(args);
			args.isProcessed.schema = true;

			if (!args.settings.renderWhenNoData && !this._hasData(args)) {
				return null;
			}
		} else if (args.isRoot) {
			args.path = args.parentPath;
			args.isProcessed.path = true;

			args.schema = args.parentSchema;
			args.isProcessed.schema = true;

			if (!args.settings.renderWhenNoData && !this._hasData(args)) {
				return null;
			}
		} else {
			args.isProcessed.path = true;
			args.isProcessed.schema = true;
		}

		if (args.children) {
			args.renderedChildren = this._renderChildren(args);

			if (!args.settings.renderWhenEmpty && !this._hasChildren(args)) {
				return null;
			}

			args.props.children = args.renderedChildren;
		}

		args.isProcessed.renderedChildren = true;

		if (!args.props.key) {
			args.props.key = this._getKey(args);
		}

		args.isProcessed.key = true;

		return _react2.default.createElement(FieldComponent, args.props);
	}

	_getName(args) {
		let name = args.plan.name;


		if (typeof name === 'function') {
			name = name(args);
		}

		return name;
	}

	_processDynamic(args) {
		if (args.plan && args.plan.dynamic) {
			var _args$plan = args.plan;
			let processor = _args$plan.processor;
			var _args$plan$processorA = _args$plan.processorArgs;
			let processorArgs = _args$plan$processorA === undefined ? {} : _args$plan$processorA;

			processor = this.constructor.processorStore.get(processor).processor;
			args.plan = processor(processorArgs, args);
		}
	}

	_getFieldComponent(_ref3) {
		let name = _ref3.name;

		var _constructor$store$ge = this.constructor.store.get({ namespace: this.namespace, name });

		const component = _constructor$store$ge.component;

		return component;
	}

	_getProps(args) {
		const props = args.plan.props;


		if (typeof props === 'function') {
			return props(args);
		}

		return props;
	}

	_getChildren(args) {
		const children = args.plan.children;


		if (typeof children === 'function') {
			return children(args);
		}

		return children;
	}

	_getPath(_ref4) {
		let parentPath = _ref4.parentPath,
		    props = _ref4.props;

		return parentPath.push(props.path);
	}

	_getSchema(_ref5) {
		let parentSchema = _ref5.parentSchema,
		    props = _ref5.props;

		return parentSchema.extract({ path: new _flexschema.Path({ path: props.path }) });
	}

	_getKey(_ref6) {
		let plan = _ref6.plan,
		    key = _ref6.key;

		if (plan.key !== undefined) {
			return plan.key;
		}

		return key;
	}

	_renderChildren(_ref7) {
		let children = _ref7.children,
		    parentPath = _ref7.parentPath,
		    path = _ref7.path,
		    parentSchema = _ref7.parentSchema,
		    schema = _ref7.schema;

		if (Array.isArray(children)) {
			return children.map((plan, index) => this._getComponent({
				plan,
				parentPath: path ? path : parentPath,
				parentSchema: schema ? schema : parentSchema,
				key: index
			})).filter(child => !!child);
		}
		return this._getComponent({
			plan: children,
			parentPath: path ? path : parentPath,
			parentSchema: schema ? schema : parentSchema
		});
	}

	_hasData(args) {
		return args.path.getData({ data: this.data }) !== undefined;
	}

	_hasChildren(args) {
		return !Array.isArray(args.renderedChildren) && args.renderedChildren || Array.isArray(args.renderedChildren) && args.renderedChildren.length;
	}
};
exports.default = Architect;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _flexstore = __webpack_require__(3);

var _flexstore2 = _interopRequireDefault(_flexstore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ProcessorStore = class ProcessorStore extends _flexstore2.default {

	has(_ref) {
		let namespace = _ref.namespace,
		    name = _ref.name;

		return super.has({ path: [namespace, name] });
	}

	set(_ref2) {
		let namespace = _ref2.namespace,
		    name = _ref2.name,
		    processor = _ref2.processor;

		super.set({
			path: [namespace, name],
			value: {
				processor
			}
		});
	}

	get(_ref3) {
		let namespace = _ref3.namespace,
		    name = _ref3.name;

		return super.get({ path: [namespace, name] });
	}

	remove(_ref4) {
		let namespace = _ref4.namespace,
		    name = _ref4.name;

		if (this.has({ namespace, name })) {
			super.remove({ path: [namespace, name] });
		}
	}
};
exports.default = ProcessorStore;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _FlexForm = __webpack_require__(4);

Object.defineProperty(exports, 'default', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FlexForm).default;
  }
});

var _flexify = __webpack_require__(6);

Object.defineProperty(exports, 'flexify', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_flexify).default;
  }
});

var _FlexFormError = __webpack_require__(5);

Object.defineProperty(exports, 'FlexFormError', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FlexFormError).default;
  }
});

var _FieldStore = __webpack_require__(2);

Object.defineProperty(exports, 'FieldStore', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FieldStore).default;
  }
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = require("extendable-error");

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("lodash/isEqual");

/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = require("object-path-immutable");

/***/ })
/******/ ]);